// Imprécision numériques qui mène à des erreurs.
#include <iostream>
#include <cmath>     // pour les fonctions mathématiques,  sqrt = racine carrée.
#include <stdio.h>

using namespace std;

int test01()
//==========
{
float vX0, vX1, vX2;
int nCpt;

// x^2 = x + 1,  donc  x^(n+1) = x^n + x^(n-1),  converge vers 0 théoriquement
// pour x = vX1;

vX0 = 1.0;
vX1 = (1 - sqrt(5)) / 2;
printf("x^0  =   1\nx    = %9.5f\n", vX1);

for (nCpt = 2; nCpt <= 45; nCpt++) {
  vX2 = vX1 + vX0;
//  cout << 10000+nCpt << "  " << vX2 << endl;
  printf("x^%2d = %9.5f\n", nCpt, vX2);

  vX0 = vX1;
  vX1 = vX2;
  }

return 0;
} // test01

int test02()
//==========
// Erreur de ((x+1)^3 - 3*x*(x+1) - 1) / x^3
{
float vX, vX1, vFX;
int nCpt;

for (nCpt = -1; nCpt >= -10; nCpt--) {
  vX  = pow(10, nCpt);
  vX1 = vX + 1;
  vFX = (vX1*vX1*vX1 - 3*vX*(vX+1) - 1) / (vX*vX*vX);
  printf("x = %8.0e  F(x) = %15.8f\n", vX, vFX);
  }

return 0;
} // test02

int test03()
//==========
// Erreur de ((x+1)^2 - 1) / x
{
float vX, vX1, vFX;
int nCpt;

vX=10;
for (nCpt = 1; nCpt <= 45; nCpt++) {
 vX = vX*10;
 cout << vX << endl;
 }


for (nCpt = -1; nCpt >= -25; nCpt--) {
  vX  = pow(10, nCpt);
  vX1 = vX + 1;
//  vFX = (vX1*vX1 - 1) / vX;
  vFX = (vX1*vX1 - 1);
  vFX = vFX / vX;
  printf("x = %8.0e  F(x) = %15.8f\n", vX, vFX);
  }

return 0;
} // test03

int test04()
//==========
// Précision des calculs, nombre tel que 1+e != 1
{
//float vE, vE1;
double vE, vE1;
int nCpt = 0;

vE  = 1;
vE1 = 1 + vE;

do {
  printf("n, e = %4d %12.6e\n", nCpt, vE);

  nCpt++;
  vE  = vE / 2.0;
  vE1 = 1 + vE;
  } while (vE1 != 1);

return 0;
} // test04


int main()
{
test01();
}


























